<%
'===========================================================================
' This is a sample script provided by Zip-Codes.com to show the logic and 
' basic programming used to do a radius search. This example assumes that
' you are using our ZIP Code Database - Deluxe Access Database
'
'===========================================================================

' Local Access DB Connection String
dbStr = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & Server.MapPath("zip-codes-database-DELUXE.mdb")

' Create Database COnnection Object
set dbConn = Server.CreateObject("ADODB.Connection")
dbConn.Open(dbStr)

' Collect variables from the posted form
zip1 = trim(request("zip1"))
if (request("zipMilesLow") <>"" AND isnumeric(request("zipMilesLow"))) then zipMilesLow = clng(request("zipMilesLow")) else zipMilesLow = 0
if (request("zipMilesHigh") <>"" AND isnumeric(request("zipMilesHigh"))) then zipMilesHigh = clng(request("zipMilesHigh")) else zipMilesHigh = 5
' Check to make sure that data is accurate
if zipMilesLow >= zipMilesHigh then
	zipMilesLow = 0
end if

' Get Data for the base ZIP Code and set to variables
if (isnumeric(zip1) AND len(zip1) = 5) then
	set getRecord = dbConn.execute("SELECT Latitude, Longitude, State, City FROM ZipCodeDatabase_DELUXE WHERE ZipCode = '" & replace(zip1, "'", "''") & "'")
		if NOT getRecord.EOF then
			zip1Latitude = cdbl(getRecord("Latitude"))
			zip1Longitude = cdbl(getRecord("Longitude"))
			zip1State = getRecord("State")
			zip1City = getRecord("City")
			zip1ZipCode = zip1
		else
			msg = 2
		end if
	set getRecord = nothing
else
	msg = 1
end if
%>

<p><b>Zip Code Radius Finder</b></p>

<% if msg > 0 then %>
	<% if msg = 1 then %><p class="errorText" align="center">Please enter a ZIP Code.</p>
	<% elseif msg = 2 then %><p class="errorText" align="center">ERROR: You entered an invalid ZIP Code.</p>
	<% end if %>
<% end if %>

<p align="center">Use this form to find what zip codes are within an X mile radius from a specific U.S. ZIP code.</p>

<form action="" method="post">
<table border="0" align="center" cellpadding="4" bordercolor="#CCCCCC">
<tr>
  <td valign="right" nowrap><strong>Find all ZIP Codes within</strong></td>
  <td valign="middle">
    <input name="zipMilesLow" type="text" id="zipMilesLow" value="<%=zipMilesLow%>" size="5" maxlength="5">
  </td>
</tr>
<tr>
  <td align="right" valign="right" nowrap><strong>And</strong></td>
  <td valign="middle">
    <input name="zipMilesHigh" type="text" id="zipMilesHigh" value="<%=zipMilesHigh%>" size="5" maxlength="5">  </td>
</tr>
<tr>
<td width="50%"><div align="right"><strong>of this ZIP Code:</strong></div></td>
<td width="50%"><input type="text" name="zip1" id="from" maxlength="5" size="10" value="<%=zip1%>"></td>
</tr>
<tr>
 <td colspan="2" align="center" valign="middle"><input type="submit" name="Submit" value="Find Zip Codes"></td>
</tr>
</table>
</form>



<%
' If no error message and the Base ZIP Code exists, process results
if msg = 0 AND zip1 <> "" then

' Construct SQL Query from function defined below.
strSQL = zipRadiusSQL(sqlFields, zip1ZipCode, zip1Latitude, zip1Longitude, zipMilesHigh)

' Execute SQL Statement
set getRecords = dbConn.execute(strSQL)
%>
<table width="100%" border="0" align="center" cellpadding="2" cellspacing="0">
<tr><td><strong>#</strong></td><td><strong>Zip Code</strong></td><td><strong>Area Code</strong></td><td><strong>City</strong></td><td><strong>County</strong></td><td><strong>State</strong></td><td><strong>Distance</strong></td></tr>
<%
' Print no records found error message
if getRecords.EOF then
%>
<tr><td colspan="6"><p align="center">Sorry, no records match your query.s</p></td></tr>
<%
end if

' Loop through all matching records, set data to variables, do actual distance calculation, and print matching records.
while NOT getRecords.EOF AND response.isclientconnected
	onRec = onRec + 1
		' Set the data to variables
		zipLatitude = cdbl(getRecords("Latitude"))
		zipLongitude = cdbl(getRecords("Longitude"))
		zipState = getRecords("State")
		zipZipCode = getRecords("ZipCode")
		zipAreaCode = getRecords("AreaCode")
		zipCity = getRecords("City")
		zipCounty = getRecords("County")
		' Calculate actual distance (in miles) using the Distance Function defined below
		zipDistance = cdbl("0" & zipDistCalc(zip1Latitude, zip1Longitude, zipLatitude, zipLongitude, "M"))

		' If the Zip Code is within the range specified, print it
		if zipDistance > zipMilesLow AND zipDistance < zipMilesHigh then
%><tr><td><b><%=onRec%></b></td><td><%=zipZipCode%></td><td><%=zipAreaCode%></td><td><%=zipCity%></td><td><%=zipCounty%></td><td><%=zipState%></td><td><%=formatnumber(zipDistance, 3, -2, -2, -2)%> miles</td></tr>
<%
		else
			' Remove one from the matching records count to keep our count accurate
			onRec = onRec - 1
		end if
getRecords.movenext()
wend

' If there are more than 25 records, print an extra key at the bottom for easier identification of column data
if onRec >= 25 then
%>
<tr><td><strong>#</strong></td><td><strong>Zip Code</strong></td><td><strong>Area Code</strong></td><td><strong>City</strong></td><td><strong>County</strong></td><td><strong>State</strong></td><td><strong>Distance</strong></td></tr>
<%
end if
%>
</table>

<p align="center">Found <strong><%=onRec%></strong> matches.</p>

<%
end if
%>

      </td>
	</tr>
	</table>          






<%
'=======================================================================================
' Function: zipRadiusSQL
'=======================================================================================
' This function Calculates the Latitude & Longitude radius (square) for records to pull.
' This function also constructs a SQL Query from these ranges and returns it
'=======================================================================================
function zipRadiusSQL(sqlFields, varZip, varLatitude, varLongitude, varMiles)
	varLatRange = varMiles / ((6076 / 5280) * 60) + (varMiles / 1000)
	varLongRange = varMiles / (((cos(cdbl(varLatitude * 3.141592653589 / 180)) * 6076.) / 5280.) * 60) + (varMiles / 1000)
		
		zipRadiusSQL_str = "SELECT Latitude, Longitude, State, ZipCode, AreaCode, City, County"
		zipRadiusSQL_str = zipRadiusSQL_str & " FROM ZipCodeDatabase_DELUXE WHERE PrimaryRecord = 'P'"
		zipRadiusSQL_str = zipRadiusSQL_str & " AND ("
			zipRadiusSQL_str = zipRadiusSQL_str & "Longitude <= (" & varLongitude & " + " & varLongRange & ")"
			zipRadiusSQL_str = zipRadiusSQL_str & " AND "
			zipRadiusSQL_str = zipRadiusSQL_str & "Longitude >= (" & varLongitude & " - " & varLongRange & ")"
		zipRadiusSQL_str = zipRadiusSQL_str & ")"
		zipRadiusSQL_str = zipRadiusSQL_str & " AND ("
			zipRadiusSQL_str = zipRadiusSQL_str & "Latitude <= (" & varLatitude & " + " & varLatRange & ")"
			zipRadiusSQL_str = zipRadiusSQL_str & " AND "
			zipRadiusSQL_str = zipRadiusSQL_str & "Latitude >= (" & varLatitude & " - " & varLatRange & ")"
		zipRadiusSQL_str = zipRadiusSQL_str & ")"
		if varZip <> "" then
			zipRadiusSQL_str = zipRadiusSQL_str & " AND ZipCode <> '" & varZip & "'"
		end if
		zipRadiusSQL_str = zipRadiusSQL_str & " AND Longitude <> 0"
		zipRadiusSQL_str = zipRadiusSQL_str & " AND Latitude <> 0"
		zipRadiusSQL_str = zipRadiusSQL_str & " ORDER BY ZipCode ASC"
	zipRadiusSQL = zipRadiusSQL_str
end function


'=======================================================================================
' Function: zipDistCalc
'=======================================================================================
' This function calculates the distance between two Lat/Long coordinates
'=======================================================================================
function zipDistCalc(Lat1, Lon1, Lat2, Lon2, UnitFlag)
    Dim LatRad1
    Dim LonRad1
    Dim LatRad2
    Dim LonRad2
    Dim LonRadDif
    Dim RadDist
    Dim X
    Dim PI
    Dim DistKM
    Dim DistMI
    PI = 3.141592654
    If IsNull(Lat1) Then
        Exit Function
    End If
    If Lat1 = 0 Or Lon1 = 0 Or Lat2 = 0 Or Lon2 = 0 Then
        DistCalc = Null
        Exit Function
    ElseIf Lat1 = Lat2 And Lon1 = Lon2 Then
        DistCalc = 0
        Exit Function
    End If
    LatRad1 = Lat1 * PI / 180
    LonRad1 = Lon1 * PI / 180
    LatRad2 = Lat2 * PI / 180
    LonRad2 = Lon2 * PI / 180
    LonRadDif = Abs(LonRad1 - LonRad2)
    X = Sin(LatRad1) * Sin(LatRad2) + Cos(LatRad1) * Cos(LatRad2) * Cos(LonRadDif)
    RadDist = Atn(-X / Sqr(-X * X + 1)) + 2 * Atn(1)
    DistMI = RadDist * 3958.754
    DistKM = DistMI * 1.609344
    If ucase(UnitFlag) = "M" Then
		zipDistCalc = DistMI
	Else
		zipDistCalc = DistKM
	End If
end function
%>